namespace test;

using ArchUnitNET.Domain;
using ArchUnitNET.Fluent;
using ArchUnitNET.Loader;
using ArchUnitNET.MSTestV2;
using ArchUnitNET_test;
using Refit;
using static ArchUnitNET.Fluent.ArchRuleDefinition;

[TestClass]
public class UnitTest1
{
    internal static readonly ArchUnitNET.Domain.Architecture Architecture = new ArchLoader()
        .LoadAssembliesIncludingDependencies(typeof(ITestApi).Assembly)
        .Build();

    [TestMethod]
    public void TestMethod1()
    {
        MethodMembers()
            .That()
            .HaveAnyAttributes(
                typeof(GetAttribute),
                typeof(PostAttribute),
                typeof(PutAttribute),
                typeof(DeleteAttribute)
            )
            .And()
            .AreDeclaredIn(Interfaces())
            .Should()
            .BeDeclaredIn("^.*Api$", true)
            .Because("All interfaces with Refit attributes should end with 'Api'")
            .Check(Architecture);
    }
}
